<script setup lang="ts">
import { onMounted, reactive } from 'vue'

// import * as bygonz from 'bygonz'
import { doTest, liveQuery } from 'bygonz'
import type { FriendsDB, Table } from 'bygonz'
// import { Dexie } from 'bygonz'

import Graph from 'graphology'
import chroma from 'chroma-js'
import Sigma from 'sigma'
import ForceSupervisor from 'graphology-layout-force/worker'

// const ztaxCDNURL = 'https://ztax-cdn.fission.app/bygonz/index.mjs'
// const bygonz: typeof Tbygonz = await import(/* @vite-ignore */ztaxCDNURL)
// const { doTest, liveQuery } = bygonz
const { friendsDB } = await doTest() as { friendsDB: FriendsDB & { Friends: Table; Connections: Table } }
const friendsTable = friendsDB.Friends

// const friends = useObservable(liveQuery(() => db.Friends.toArray()) as any) as Ref<Friend[]> // only shows the first array non-reactive
// consider https://github.com/dexie/Dexie.js/issues/1528#issuecomment-1085388832
const rxState = reactive({
  allFriends: await friendsTable.toArray(),
  allConnections: await friendsDB.Connections.toArray(),
})

const graph = new Graph()

for (const [idx, eachF] of rxState.allFriends.entries())
  graph.addNode(eachF.ID, { x: 0, y: idx * 10, size: 10, color: chroma.random().hex() })

for (const [_idx, eachC] of rxState.allConnections.entries())
  graph.addEdge(eachC.fromFriend, eachC.toFriend)

// Create a sample graph

graph.addNode('n1', { x: 0, y: 0, size: 10, color: chroma.random().hex() })
graph.addNode('n2', { x: -5, y: 5, size: 10, color: chroma.random().hex() })
graph.addEdge('n1', 'n2')

const friendsObservable = liveQuery(() => {
  // return friendsDB.transaction('r!', friendsTable, () =>
  // return Dexie.waitFor(
  return friendsTable.toArray()
  // )
})
friendsObservable.subscribe({
  next: async (result: any[]) => {
    console.log('Got result in vue: ', { result })
    const resultWithAgeHistory = []
    for (const eachFriend of result) {
      resultWithAgeHistory.push({
        ...eachFriend,
        // ageHistory: (await eachFriend.getAttributeHistoryArray('age')).join(', '),
      })
    }

    rxState.allFriends = resultWithAgeHistory
  },
  error: error => console.error(error),
})

console.log({ db: friendsDB, rxState })

const sigma = ref()

// Create the spring layout and start it
const layout = new ForceSupervisor(graph, { isNodeFixed: (_, attr) => attr.highlighted })
layout.start()

onMounted(() => {
  // Create the sigma instance using the value of the vue ref - which returns the div HTMLElement
  const renderer = new Sigma(graph, sigma.value)

  console.log({ renderer, graph, layout })
})

// more sigma example stuff
// https://codesandbox.io/s/github/jacomyal/sigma.js/tree/main/examples/mouse-manipulations?file=/index.ts:0-1002
// https://github.com/jacomyal/sigma.js/tree/main/examples
</script>

<template>
  <div flex="~ row justify-around">
    <div ref="sigma" class="w-800px h-600px" />
    <ul class="max-w-md m-auto">
      <li v-for="friend in rxState.allFriends" :key="friend.id" class="text-left">
        {{ friend.name }}, {{ friend.age }}{{ friend.ageHistory?.length ? `, Previous ages: ${friend.ageHistory}` : '' }}
      </li>
    </ul>
  </div>
</template>
